#include "list.h"
#include <stdlib.h>

#define PI 3.14159265

void Insertar(Lista *lista,Lista *ultimo, TD v) {
/*insertar al final*/	
   	pNodo nuevo, aux;
 
   	/* Crear un nodo nuevo */
   	nuevo = (pNodo)malloc(sizeof(NODO));
	nuevo->Val.x = v.x;
	nuevo->Val.y = v.y;
	nuevo->Val.radio1 = v.radio1;
	nuevo->Val.radio2 = v.radio2;
	nuevo->Val.angle1 = v.angle1;
	nuevo->Val.angle2 = v.angle2;
	nuevo->sig=NULL;
   		
 	/* Si la lista está vacía */
   	if(ListaVacia(*lista)) {
      	/* Añadimos la lista a continuación del nuevo nodo */
      	nuevo->sig = *lista;
      	/* Ahora, el comienzo de nuestra lista es en nuevo nodo */
      	*lista = nuevo;
		*ultimo=nuevo;
   	}else{      	
      	aux = *lista;
      	/* Avanzamos hasta el último elemento */
	   	while(aux->sig) 
        	aux = aux->sig;
      	/* Insertamos el nuevo nodo después del nodo anterior */
      	nuevo->sig = aux->sig;
      	aux->sig = nuevo;
		*ultimo=nuevo;
   }
}
int ListaVacia(Lista lista){
   return (lista == NULL);
}

void BorrarLista(Lista *lista) {
   pNodo nodo;

   while(*lista) {
      nodo = *lista;
      *lista = nodo->sig;
      free(nodo);
   }
}
int getLenght(Lista l){
   	pNodo nodo = l;
	int lenght=0;
	if(ListaVacia(l)) return 0;
   	else {
      	while(nodo) {
		 	lenght++;
         	nodo = nodo->sig;
     	}     	
   	}
	return lenght;
}
TD nuevoTD(float x, float y){
	TD P;
	P.x = x;
	P.y = y;
	P.radio1=P.angle1=P.radio2=P.angle2=P.split=0;	
   	return (P);
}
void setPoint(Lista p,float x,float y){
	p->Val.x=x;
	p->Val.y=y;
}
void setTg1(Lista p,float p1x,float p1y,float p2x,float p2y){
	float rd=0,ag=0;
	float d1x,d1y,d2x,d2y,dx,dy;
	//printf("settg1\n");	
	d1x=p1x*60;
	d1y=p1y*60;
	d2x=p2x*60;
	d2y=p2y*60;	
	dx=d2x-d1x;
	dy=d2y-d1y;	
	dx=dx*3;
	dy=dy*3;	
	dx=dx/60;
	dy=dy/60;	
	
	rd=sqrt(dx*dx + dy*dy);
		
	if(dx>0 && dy>0){ 
		ag=PI + atan(dy/dx);
	//	printf("caso 180-270\n");
	}else if(dx>0 && dy<0){ 
		ag=PI + atan(dy/dx);
//		printf("caso 90-180\n");		
	}else if(dx<0 && dy<0){ 
		ag=atan(dy/dx);
		//printf("caso 0-90\n");
	}else if(dx<0 && dy>0){ 
		ag= 2*PI+atan(dy/dx);
		//printf("caso 270-360\n");
	}else if(dx==0 && dy>0){
		ag=-1*PI/2;
	}else if(dx==0 && dy<0){
		ag=PI/2;
	}else if(dx==0 && dy==0){
		ag=0;
	}else if(dx<0 && dy==0){
		ag=0;
	}else if(dx>0 && dy==0){
		ag=PI;
	}else{
		printf("NUNCA ENTRE\n\n");
	}
	ag= (ag*180)/PI;
	
	//printf("sale radio= %f angulo=%f\n",rd,ag);
	//printf("\n");
	
	p->Val.radio1=rd;
	p->Val.angle1=ag;	
}
//1 es punto normal y 2 es punto de control
void setTg2(Lista p,float p1x,float p1y,float p2x,float p2y){
	float rd=0,ag=0;
	float d1x,d1y,d2x,d2y,dx,dy;
	//printf("settg2\n");
	//printf("vino un (%f,%f) (%f,%f)\n",p1x,p1y,p2x,p2y);
	d1x=p1x*60;
	d1y=p1y*60;
	d2x=p2x*60;
	d2y=p2y*60;
	//printf("one %f %f\n",d2x,d2y);
	dx=d2x-d1x;
	dy=d2y-d1y;
	//printf("two %f %f\n",dx,dy);
	dx=dx*3;
	dy=dy*3;
	dx=dx/60;
	dy=dy/60;
	//printf("luego conseguimos dx=%f y dy=%f\n",dx,dy);
	
	rd=sqrt(dx*dx + dy*dy);
	if(dx>0 && dy>0){ 
		ag=PI + atan(dy/dx);
	//	printf("caso 180-270\n");
	}else if(dx>0 && dy<0){ 
		ag=PI + atan(dy/dx);
	//	printf("caso 90-180\n");		
	}else if(dx<0 && dy<0){ 
		ag=atan(dy/dx);
	//	printf("caso 0-90\n");
	}else if(dx<0 && dy>0){ 
		ag= 2*PI+atan(dy/dx);
	//	printf("caso 270-360\n");
	}else if(dx==0 && dy>0){
		ag=-1*PI/2;
	}else if(dx==0 && dy<0){
		ag=PI/2;
	}else if(dx==0 && dy==0){
		ag=0;
	}else if(dx<0 && dy==0){
		ag=0;
	}else if(dx>0 && dy==0){
		ag=PI;
	}else{
		printf("NUNCA ENTRE\n\n");
	}
	ag= (ag*180)/PI;
	/*reverse*/
	ag=ag-180;	
	
	p->Val.radio2=rd;
	p->Val.angle2=ag;	
}
void setSplit(Lista p,int flag){	
	if(p!=NULL){
		p->Val.split=flag;
	}
}

void ImprimirLista(Lista p){
	pNodo a;
	a=p;
	int i=1;
	while(a->sig){
		printf("Nodo %i:\n",i);
		printf("\t Point ( %f , %f )\n",a->Val.x,a->Val.y);
		printf("\t Tang1 ( %f , %f )\n",a->Val.radio1,a->Val.angle1);
		printf("\t Tang2 ( %f , %f )\n",a->Val.radio2,a->Val.angle2);	
		a=a->sig;
		i++;
	}
}
void ImprimirNodo(Lista a){
	if(a!=NULL){
		printf("Nodo\n");	
		printf("\t Point ( %f , %f )\n",a->Val.x,a->Val.y);
		printf("\t Tang1 ( %f , %f )\n",a->Val.radio1,a->Val.angle1);
		printf("\t Tang2 ( %f , %f )\n",a->Val.radio2,a->Val.angle2);
	}else{
		printf("Nodo nulo\n");
	}
}
int isFirst(Lista nodo,float a, float b){
	if(nodo->Val.x==a && nodo->Val.y==b)
		return 1;
	return 0;
}

Node * node_add (Node * list, void * data)
{
	Node * new;

	new = (Node *) malloc (sizeof (Node));

	if (! new)
	{		
		exit (1);
	}

	new->data = data;
	new->next = list;
	
	return new;
}
LinearGradient* 
nuevoLinearGradient
(char* name,float x1,float y1, float x2,float y2,Node* stops)
{
	LinearGradient* P;
	P=(LinearGradient*)malloc(sizeof(LinearGradient));
	sprintf(P->name,"%s",name);
	P->x1=x1;
	P->y1=y1;
	P->x2=x2;
	P->y2=y2;
	P->stops=stops;
   	return P;
}
Url* nuevoUrl(int type,void* data){
	Url* P;
	P=(Url*)malloc(sizeof(Url));
	P->type=type;
	P->data=data;
	return (P);
}
Stop* nuevoStop(char* color,float opacity,float pos){
	Stop* _stop;
	_stop=(Stop*)malloc(sizeof(Stop));	
	_stop->r=getRed(color)/256.0;	
	_stop->g=getGreen(color)/256.0;
	_stop->b=getBlue(color)/256.0;
	_stop->a=opacity;
	_stop->pos=pos;
	return _stop;
}
void ImprimirUrls(Node* a){
	Node *aux;
	Url* aux2;
	aux=a;
	int i=0;	
	while(aux!=NULL){
		aux2=(Url*)aux->data;
		if(aux2->type==0){
			printf("Gradiente Linear\n");
			LinearGradient* aux3=(LinearGradient*)aux2->data;
			printf("\t %s \n",aux3->name);
			printf("\t1. ( %f , %f )\n",aux3->x1,aux3->y1);
			printf("\t2. ( %f , %f )\n",aux3->x2,aux3->y2);
			ImprimirStops(aux3->stops);
		}
		i++;
		aux=aux->next;
	}	
}
void ImprimirStops(Node* a){
	Node *aux;
	Stop* aux2;
	aux=a;		
	while(aux!=NULL){
		aux2=(Stop*)aux->data;
		printf("\tStop\n");
		printf("\t (%f , %f , %f , %f)\n",aux2->r,aux2->g,aux2->b,aux2->a);
		printf("\t pos = %f\n",aux2->pos);
		aux=aux->next;
	}
}
Node* getStopsUrls(Node* a,char* buscado){
	Node *aux;
	Url* aux2;
	aux=a;
	while(aux!=NULL){
		aux2=(Url*)aux->data;
		if(aux2->type==0){
			LinearGradient* aux3=(LinearGradient*)aux2->data;
			if(strcmp(aux3->name,buscado)==0){
				return aux3->stops;
			}
		}
		aux=aux->next;
	}
	return NULL;
}
Url* getUrls(Node* a,char* buscado){
	Node *aux;
	Url* aux2;
	aux=a;
	while(aux!=NULL){
		aux2=(Url*)aux->data;
		if(aux2->type==0){
			LinearGradient* aux3=(LinearGradient*)aux2->data;
			if(strcmp(aux3->name,buscado)==0){
				return aux2;
			}
		}		
		aux=aux->next;
	}
	return NULL;
}
int countNodes(ListaLista cab){
	int n=0;
	ListaLista ll;
	ll=cab;
	for (n = 0; ll; ll = ll->next){
		n++;
	}
	return n;
}
void ImprimirListaLista(ListaLista p){
	ListaLista a;	
	a=p;	
	while(a!=NULL){
		ImprimirLista ((Lista)a->data);		
		getchar ();
		a=a->next;
	}
}
