#include "strext.h"
#include <ctype.h>

void cortar(char * str, char * corte, int inicio, int fin) {
  //corte debe tener capacidad para fin-inicio+1 caracteres
	
  strncpy(corte, str + inicio, fin - inicio);
  corte[fin - inicio] = 0;
}
int strchar(char *s1,char *s2){
	int i=0;
	while(i<strlen(s1)){		
		if(s1[i]==s2[0]){
			i++;
			return i;
		}
		i++;
	}
	return 0;
}
int strrchar(char *s1,char *s2){
	int i=strlen(s1);
	while(i>=0){
		if(s1[i]==s2[0]){
			return i;
		}
		i--;
	}
	return 0;
}
int strContains(char *s1,char *s2){
	if(!s1 && !s2){
		return -1;		
	}
	int i,j,encontro;
	i=j=0;
	encontro=-1;
	while(i<strlen(s1)){		
		if(s1[i]==s2[0]){
			encontro=i;
			j=0;
			while(j<strlen(s2) && !(encontro==-1)){
				if(s1[i+j]!=s2[j]){
					encontro=-1;					
				}
				j++;
			}
			if(encontro!=-1){
				return encontro;
			}	
		}
		i++;
	}
	return encontro;
}

int potencia (int x, int y){          /*CALCULA LA POTENCIA DE UN Nº*/
   int resul;
   if (y== 0)                        //Condición de salida
      resul= 1;
   else
   {                                 //Se utiliza la recursividad
      y--;
      resul= x* potencia (x, y);
   }
   return resul;
}
int hextodec(char* hex){
	int result;
	int top=strlen(hex);
	int ihex[3];
	int i=0;
	while(i<top){
		if(hex[i]=='0')
			ihex[i]=0;
		if(hex[i]=='1')
			ihex[i]=1;
		if(hex[i]=='2')
			ihex[i]=2;
		if(hex[i]=='3')
			ihex[i]=3;	
		if(hex[i]=='4')
			ihex[i]=4;		
		if(hex[i]=='5')
			ihex[i]=5;		
		if(hex[i]=='6')
			ihex[i]=6;		
		if(hex[i]=='7')
			ihex[i]=7;		
		if(hex[i]=='8')
			ihex[i]=8;		
		if(hex[i]=='9')
			ihex[i]=9;		
		if(hex[i]=='a')
			ihex[i]=10;		
		if(hex[i]=='b')
			ihex[i]=11;		
		if(hex[i]=='c')
			ihex[i]=12;		
		if(hex[i]=='d')
			ihex[i]=13;		
		if(hex[i]=='e')
			ihex[i]=14;
		if(hex[i]=='f')
			ihex[i]=15;
		i++;
	}	
	i=0;
	result=0;	
	while(i<top){
		result+=potencia(16,i)*ihex[top-i-1];
		i++;
	}
	return result;
}
int getRed(char *hex){	
	if(hex[0]=='#'){
		char red[3];
		cortar(hex,red,1,3);
		return hextodec(red);
	}else{		
		if(strncmp(hex,"rgb",3)==0 || strncmp(hex,"RGB",3)==0){			
			char* str1;
			char str[20];
			cortar(hex,str,strchar(hex,"("),strrchar(hex,")"));			
			str1=strtok(str,",");			
			return atoi(str1);
		}	
	}
	return 0;
}
int getGreen(char *hex){
	if(hex[0]=='#'){
		char green[3];
		cortar(hex,green,3,5);
		return hextodec(green);
	}else{		
		if(strncmp(hex,"rgb",3)==0 || strncmp(hex,"RGB",3)==0){			
			char* str1;
			char str[20];
			cortar(hex,str,strchar(hex,"("),strrchar(hex,")"));			
			str1=strtok(str,",");			
			str1=strtok(NULL,",");			
			return atoi(str1);
		}
	}
	return 0;
}
int getBlue(char *hex){
	if(hex[0]=='#'){
		char blue[3];
		cortar(hex,blue,5,7);
		return hextodec(blue);
	}else{
		if(strncmp(hex,"rgb",3)==0 || strncmp(hex,"RGB",3)==0){			
			char* str1;
			char str[20];
			cortar(hex,str,strchar(hex,"("),strrchar(hex,")"));			
			str1=strtok(str,",");			
			str1=strtok(NULL,",");			
			str1=strtok(NULL,",");			
			return atoi(str1);
		}
	}
	return 0;
}

xmlChar * ConvertInput(const char *in, const char *encoding){
    xmlChar *out;
    int ret;
    int size;
    int out_size;
    int temp;
    xmlCharEncodingHandlerPtr handler;

    if (in == 0)
        return 0;

    handler = xmlFindCharEncodingHandler(encoding);

    if (!handler) {
        printf("ConvertInput: no encoding handler found for '%s'\n",
               encoding ? encoding : "");
        return 0;
    }

    size = (int) strlen(in) + 1;
    out_size = size * 2 - 1;
    out = (unsigned char *) xmlMalloc((size_t) out_size);

    if (out != 0) {
        temp = size - 1;
        ret = handler->input(out, &out_size, (const xmlChar *) in, &temp);
        if ((ret < 0) || (temp - size + 1)) {
            if (ret < 0) {
                printf("ConvertInput: conversion wasn't successful.\n");
            } else {
                printf
                    ("ConvertInput: conversion wasn't successful. converted: %i octets.\n",
                     temp);
            }

            xmlFree(out);
            out = 0;
        } else {
            out = (unsigned char *) xmlRealloc(out, out_size + 1);
            out[out_size] = 0;  /*null terminating out */
        }
    } else {
        printf("ConvertInput: no mem\n");
    }

    return out;
}

int xmlCharToInt(xmlChar * str){
	int ans =0;
	while(str[0] != '\0'){
		ans *=10;
		ans += (str[0] - '0');
		str++;
	}
	return ans;
}
float xmlCharToFloat(xmlChar *str){
	return atof(str);
}

int extractSubAttribute(xmlChar* attribute, char* name,char* value){
	char str[512];
	sprintf(str,"%s",attribute);	
	char *str1; //subattribute
	
	char str_attri[40]; //subattribute
	char str_local[40]; //subattribute localname
	char str_value[40]; //subattribute value
	str1 = strtok(str, ";");
	int encontro=0;
	while (1){
		if (str1 == NULL){
			break;
		}else{
			sprintf(str_attri,"%s",str1);			
			int medio=strchar(str_attri,":")-1;
			int fin=strlen(str_attri);
			cortar(str_attri,str_local,0,medio);
			cortar(str_attri,str_value,medio+1,fin);			
			if(strcmp(str_local,name)==0){
				removeSpaces(str_value);
				sprintf(value,"%s",str_value);
				encontro=1;
			}
		}
		str1 = strtok(NULL, ";");
    }
	return encontro;
}
void removeSpaces(char* a){
	int length,i;
	length = strlen(a); //Hallo la longitud de la cadena
	char aux[20];
	sprintf(aux,"");
	for (i=0; i<length; i++){
      if(a[i]!=' '){
		  sprintf(aux,"%s%c",aux,a[i]);
	  }
   	}
	sprintf(a,"%s",aux);
}
void strLowerCase(char* a){
	int length, i; 
   	length = strlen(a); //Hallo la longitud de la cadena
    for (i=0; i<length; i++){
      a[i] = tolower(a[i]); //Caracter a caracter la paso a mayuscula
   	}
}
void getNextItemPath(char* path,char* item,int n_item){
	int length,i,j;
	i=j=0;
	length=strlen(path);
	int isVx=0;	
	while(i<length){		
		if(isCommand(path[i])){
			j++;
			if(j==n_item){
				sprintf(item,"%c",path[i]);
				return;
			}
		}else{
			if(isdigit(path[i]) || path[i]=='.' || path[i]==',' || path[i]=='-'){
				
				j++;
				sprintf(item,"");
				isVx=0;
				while(i<length){
					if(isCommand(path[i])){
					//	printf("es comando %s\n",item);
						if(j==n_item){
							return;
						}
						i--;
						break;
					}
					if(path[i]==',' && isVx==0){
				//		printf("es coma aun vector %s\n",item);
						isVx=1;
					}
					if(path[i]==' ' && isVx==0){
						isVx=1;
						sprintf(item,"%s%c",item,',');
					//	printf("espacio en blanco recien vector %s\n",item);
					}else{
						if(path[i]==' ' && isVx==1){
					//		printf("espacio en blando y ya es vector asi que sale %s\n",item);
							if(j==n_item){
								return;
							}
							break;
						}
					}
					if(path[i]!=' ' && j==n_item){			
						sprintf(item,"%s%c",item,path[i]);
					//	printf("add %s\n",item);
					}
					i++;
				}
			}
		}
		i++;
	}
	if(j!=n_item){
		sprintf(item,"NULL");
	}
}

/*dont have smooth,vertical or horizontal commands*/
int isCommand(char p){
	return ( p=='z' ||p=='q' ||p=='c' ||p=='m' ||p=='l');
}
void loadAttribute(xmlChar* path_style,xmlChar* master_style,char* name,char* value,char* defaultVal){
	int fnd=0;
	if(path_style){		
		fnd=extractSubAttribute(path_style,name,value);		
	}else{
		if(master_style){
			fnd=extractSubAttribute(master_style,name,value);
		}else{
			sprintf(value,defaultVal);
		}
	}
	if(fnd==0){
		sprintf(value,"%s",defaultVal);
	}
}

void generateGUID(char* cguid){
	//cguid debe tener espacio suficiente
	int i;
	sprintf(cguid,"");
	for(i=0;i<32;i++){
		sprintf(cguid,"%s%c",cguid,randomLetter());
	}	
}
int randomLetter(){
	int a=random()%2;
	if(a) return (49 + random()%9);
	else return  (65 + random()%24);
}
int isVector(char* cvector){
	int length=strlen(cvector);
	int i=0;
	while(i<length){
		if(cvector[i]==','){
			return 1;
		}			
		i++;		
	}
	return 0;
}
void getPixel(char *ac,float *af){
	int length=strlen(ac);
	if(isdigit(ac[length-1])){
		*af=atof(ac);
	}else{
		char mtc[3];
		char nmc[12];
		cortar(ac,mtc,length-2,length);
		cortar(ac,nmc,0,length-2);		
		if(strcmp(mtc,"px")==0){
			*af=atof(nmc);
		}else if(strcmp(mtc,"pt")==0){
			*af=atof(nmc)*1.25;
		}else if(strcmp(mtc,"em")==0){
			*af=atof(nmc)*16;
		}else if(strcmp(mtc,"mm")==0){
			*af=atof(nmc)*3.54;
		}else if(strcmp(mtc,"pc")==0){
			*af=atof(nmc)*15;
		}else if(strcmp(mtc,"cm")==0){
			*af=atof(nmc)*35.43;
		}else if(strcmp(mtc,"in")==0){
			*af=atof(nmc)*90;			
		}		
	}	
}
Matrix newMatrixf(float a,float b,float c,float d,float e,float f){
	Matrix data;
	data=(Matrix)malloc(sizeof(Matrix3x3));
	data->a=a;
	data->b=b;
	data->c=c;
	data->d=d;
	data->e=e;
	data->f=f;
	return data;
}
Matrix newMatrixs(char* mvector){
	Matrix data;
	data=(Matrix)malloc(sizeof(Matrix3x3));
	char str[100];
	char* str1;
	sprintf(str,"%s",mvector);
	str1=strtok(str,",");
	data->a=atof(str1);
	str1=strtok(NULL,",");
	data->b=atof(str1);
	str1=strtok(NULL,",");
	data->c=atof(str1);
	str1=strtok(NULL,",");
	data->d=atof(str1);
	str1=strtok(NULL,",");
	data->e=atof(str1);
	str1=strtok(NULL,",");
	data->f=atof(str1);
	return data;
}
void transformPoint2D(Matrix mtx,float *a,float *b){
	float auxa,auxb;
	auxa=0;
	auxb=0;
	auxa= (*a)*(mtx->a) + (*b)*(mtx->c) + (mtx->e);
	auxb= (*a)*(mtx->b) + (*b)*(mtx->d) + (mtx->f);
	*a=auxa;
	*b=auxb;
	return;
}

void composeMatrix(Matrix* mtx,Matrix mtx1,Matrix mtx2){
	Matrix aux;
	aux=newMatrixf(0,0,0,0,0,0);
	aux->a=(mtx1->a)*(mtx2->a)+(mtx1->c)*(mtx2->b);
	aux->b=(mtx1->b)*(mtx2->a)+(mtx1->d)*(mtx2->b);
	aux->c=(mtx1->a)*(mtx2->c)+(mtx1->c)*(mtx2->d);
	aux->d=(mtx1->b)*(mtx2->c)+(mtx1->d)*(mtx2->d);
	aux->e=(mtx1->a)*(mtx2->e)+(mtx1->c)*(mtx2->f)+(mtx1->e);
	aux->f=(mtx1->b)*(mtx2->e)+(mtx1->d)*(mtx2->f)+(mtx1->f);
	*mtx=aux;
}
void multiplyMatrix(Matrix* mtx1,Matrix mtx2){
	Matrix aux;
	aux=newMatrixf(0,0,0,0,0,0);
	aux->a=((*mtx1)->a)*(mtx2->a)+((*mtx1)->c)*(mtx2->b);
	aux->b=((*mtx1)->b)*(mtx2->a)+((*mtx1)->d)*(mtx2->b);
	aux->c=((*mtx1)->a)*(mtx2->c)+((*mtx1)->c)*(mtx2->d);
	aux->d=((*mtx1)->b)*(mtx2->c)+((*mtx1)->d)*(mtx2->d);
	aux->e=((*mtx1)->a)*(mtx2->e)+((*mtx1)->c)*(mtx2->f)+((*mtx1)->e);
	aux->f=((*mtx1)->b)*(mtx2->e)+((*mtx1)->d)*(mtx2->f)+((*mtx1)->f);
	(*mtx1)->a=aux->a;
	(*mtx1)->b=aux->b;
	(*mtx1)->c=aux->c;
	(*mtx1)->d=aux->d;
	(*mtx1)->e=aux->e;
	(*mtx1)->f=aux->f;
}

void printfMatrix(Matrix mtx){
	if(!matrixVacia(mtx)){
		printf("Matrix\n");
		printf("%3.5f %3.5f %3.5f\n",mtx->a,mtx->c,mtx->e);
		printf("%3.5f %3.5f %3.5f\n",mtx->b,mtx->d,mtx->f);
	}else{
		printf("No se pudo imprimir\n");
	}
}
int matrixVacia(Matrix mtx){
	return (mtx == NULL);
}
void getUrlName(char* car){
	char aux[40];
	cortar(car,aux,strchar(car,"("),strrchar(car,")"));
	sprintf(car,"%s",aux);
}
