#ifndef _STREXT_H
#define _STREXT_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>

#define MY_ENCODING "ISO-8859-1"

typedef struct matrix_t{
	float a,c,e;
	float b,d,f;
}Matrix3x3;
typedef Matrix3x3* Matrix;

Matrix newMatrixf(float a,float b,float c,float d,float e,float f);
Matrix newMatrixs(char* mvector);
void transformPoint2D(Matrix mtx,float *a,float *b);
int matrixVacia(Matrix mtx);
void composeMatrix(Matrix* mtx,Matrix mtx1,Matrix mtx2);
void multiplyMatrix(Matrix* mtx1,Matrix mtx2);
void printfMatrix(Matrix mtx);

int strContains(char *s1,char *s2);
int strchar(char *s1,char *s2);
int strrchar(char *s1,char *s2);
void cortar(char * str, char * corte, int inicio, int fin);
int potencia (int x, int y);
int hextodec(char *dec);
int getRed(char *hex);
int getGreen(char *hex);
int getBlue(char *hex);
xmlChar *ConvertInput(const char *in, const char *encoding);
void loadAttribute(xmlChar* path_style,xmlChar* master_style,char* name,char* value,char* defaultVal);
int extractSubAttribute(xmlChar* attribute, char* name,char* value);
float xmlCharToFloat(xmlChar *str);
int xmlCharToInt(xmlChar * str);
void strLowerCase(char* a);
char* addchar(char* cadena,char letra);
void getNextItemPath(char* path,char* item,int n_item);
void getNextItemPath2(char* path,char* item,int n_item);
int isCommand(char p);
void generateGUID(char* cguid);
int randomLetter();
int isVector(char* cvector);
void voltear(int num);
void removeSpaces(char* a);
void getPixel(char *ac,float *af);
void getUrlName(char* car);
#endif
