#ifndef _TURNLIST_H
#define _TURNLIST_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*nodo para lista de listas o listas de lo que sea xD*/
typedef struct node_t{
	struct node_t * next;
	void * data;
} Node;

typedef struct url_t{
	 int type; /* 0 linear gradients,1 radial gradients,2 gaussian blur... */
	 void* data;
}Url;
typedef struct linear_g{
	 char name[50];
	 float x1,x2,y1,y2;
	 Node* stops; //paradas de color
}LinearGradient;
typedef struct stop_t{
	 float r,g,b;
	 float a;
	 float pos;
}Stop;

typedef struct TD_t{
   	float x,y;
	float radio1,angle1;
	float radio2,angle2;
	int split;
} TD;
/*list of vectors or blines*/
typedef struct _nodo {
   TD Val;
   struct _nodo *sig;
} NODO;

typedef NODO *pNodo;
typedef NODO *Lista;
typedef Node *ListaLista;

int isFirst(Lista nodo,float a, float b);
void Insertar(Lista *l,Lista *ultimo, TD v);
int ListaVacia(Lista l);
void BorrarLista(Lista *);
void MostrarLista(Lista l);
void crearLista(Lista *l);
TD nuevoTD(float x,float y);
int getLenght(Lista l);

void setPoint(Lista p,float x,float y);
void setTg1(Lista p,float p1x,float p1y,float p2x,float p2y);
void setTg2(Lista p,float p1x,float p1y,float p2x,float p2y);
void setSplit(Lista p,int flag);
void ImprimirLista(Lista p);
void ImprimirNodo(Lista a);

Node * node_add (Node * list, void * data);
int countNodes(ListaLista cab);
void ImprimirListaLista(ListaLista p);

Stop* nuevoStop(char* color,float opacity,float pos);
Url* nuevoUrl(int type,void* data);
LinearGradient* nuevoLinearGradient(char* name,float x1,float y1, float x2,float y2,Node* stops);
void ImprimirUrls(Node* a);
void ImprimirStops(Node* a);
Node* getStopsUrls(Node* a,char* buscado);
Url* getUrls(Node* a,char* buscado);
#endif
